// VysledekDlg.cpp : implementation file
//

#include "stdafx.h"
#include "klient.h"
#include "VysledekDlg.h"
#include ".\vysledekdlg.h"


// CVysledekDlg dialog

IMPLEMENT_DYNAMIC(CVysledekDlg, CDialog)
CVysledekDlg::CVysledekDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CVysledekDlg::IDD, pParent)
	, m_strInfo(_T(""))
{
}

CVysledekDlg::~CVysledekDlg()
{
}

void CVysledekDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_TREE, m_tree);
	DDX_Text(pDX, IDC_INFO, m_strInfo);
}


BEGIN_MESSAGE_MAP(CVysledekDlg, CDialog)
END_MESSAGE_MAP()


// CVysledekDlg message handlers

BOOL CVysledekDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// TODO:  Add extra initialization here
	unsigned long mindelka = -1;
	int best = -1;
	CString strText;

	for(size_t i=0;i<m_spojeni->spoje.size();i++)
	{
		int odjezd_m, odjezd_h, prijezd_m, prijezd_h;
		COleDateTime odjezdTime, prijezdTime;
		int maxlinknum = m_spojeni->spoje[i].linky.size()-1;
		CString& odjezd = m_spojeni->spoje[i].linky[0].stanice[0].odjezd;
		CString& prijezd = m_spojeni->spoje[i].linky[maxlinknum].stanice[m_spojeni->spoje[i].linky[maxlinknum].stanice.size()-1].prijezd;

		sscanf(odjezd, "%d:%d", &odjezd_h, &odjezd_m);
		sscanf(prijezd, "%d:%d", &prijezd_h, &prijezd_m);

		int diff = (prijezd_h*60+prijezd_m) - (odjezd_h*60+odjezd_m);

		if(diff < 0)
			diff += 24*60; // je to pres pulnoc

		if(diff < mindelka)
		{
			best = i;
			mindelka = diff;
		}

		strText.Format("Spoj #%d, odjezd v %s a prijezd v %s. %d prestupu", i+1,
			odjezd,
			prijezd,
			m_spojeni->spoje[i].linky.size()-1);

		HTREEITEM hSpoj = m_tree.InsertItem(strText);
		for(size_t j=0;j<m_spojeni->spoje[i].linky.size();j++)
		{
			// najit si odjezd a prijezd linky
			int maxstanice = m_spojeni->spoje[i].linky[j].stanice.size()-1;
			strText.Format("Linka %s, odjezd v %s a prijezd v %s (%s - %s)",
				m_spojeni->spoje[i].linky[j].cislo,
				m_spojeni->spoje[i].linky[j].stanice[0].odjezd,
				m_spojeni->spoje[i].linky[j].stanice[maxstanice].prijezd,
				m_spojeni->spoje[i].linky[j].stanice[0].name,
				m_spojeni->spoje[i].linky[j].stanice[maxstanice].name);
			HTREEITEM hLinka = m_tree.InsertItem(strText, 0,0,hSpoj);

			for(size_t x=0;x<m_spojeni->spoje[i].linky[j].stanice.size();x++)
			{
				if(m_spojeni->spoje[i].linky[j].stanice[x].odjezd.IsEmpty())
				{
					strText.Format("Prijezd v %s - %s",
						m_spojeni->spoje[i].linky[j].stanice[x].prijezd,
						m_spojeni->spoje[i].linky[j].stanice[x].name);
				}
				else if(m_spojeni->spoje[i].linky[j].stanice[x].prijezd.IsEmpty())
				{
					strText.Format("Odjezd v %s - %s",
						m_spojeni->spoje[i].linky[j].stanice[x].odjezd,
						m_spojeni->spoje[i].linky[j].stanice[x].name);
				}
				else
				{
					strText.Format("Prijezd v %s a odjezd v %s - %s", m_spojeni->spoje[i].linky[j].stanice[x].prijezd,
						m_spojeni->spoje[i].linky[j].stanice[x].odjezd,
						m_spojeni->spoje[i].linky[j].stanice[x].name);
				}
				m_tree.InsertItem(strText, 0,0,hLinka);
			}

			// poznamky
			for(size_t x=0;x<m_spojeni->spoje[i].linky[j].poznamky.size();x++)
			{
				strText.Format("Poznmka: %s", m_spojeni->spoje[i].linky[j].poznamky[x]);
				m_tree.InsertItem(strText,0,0,hLinka);
			}
		}
	}

	this->m_strInfo.Format("Nejrychlej spoj je spoj #%d, do cle dorazte za %d hodin a %d minut",
		best+1, mindelka/60, mindelka%60);

	UpdateData(false);

	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}
