// klient.cpp : 
//

#include "stdafx.h"
#include "klient.h"
#include "klientDlg.h"
#include <vector>
#include ".\klient.h"
#include <msxml2.h>
#include <afxinet.h>
#include "klientFromToDlg.h"
#include "verifydlg.h"
#include "vysledekdlg.h"

using namespace std;

#ifdef _DEBUG
#define new DEBUG_NEW
#endif



// CklientApp

BEGIN_MESSAGE_MAP(CklientApp, CWinApp)
	ON_COMMAND(ID_HELP, CWinApp::OnHelp)
END_MESSAGE_MAP()


vector<CString> g_arrStations;
Spojeni g_spojeni;
VARIANT StrVar(const char* str);


CklientApp::CklientApp()
: m_strAddress(_T(""))
, m_nPort(0)
{
	
}

CklientApp theApp;

bool LoadXML(IXMLDOMDocument2* pDocument, CString strURL);
void NodeTextToCString(IXMLDOMNode* pNode, CString& out);


BOOL CklientApp::InitInstance()
{
	InitCommonControls();
	::CoInitialize(NULL);

	CWinApp::InitInstance();

	if (!AfxSocketInit())
	{
		AfxMessageBox(IDP_SOCKETS_INIT_FAILED);
		return FALSE;
	}

	AfxEnableControlContainer();

	SetRegistryKey(_T("12345"));

	CklientDlg dlg;
	CklientFromToDlg dlg2;
	CVerifyDlg dlg3;

	vector<Spoj> result;

start:

	//m_pMainWnd = &dlg;
	INT_PTR nResponse = dlg.DoModal();
	if (nResponse == IDOK)
	{
		m_nPort = dlg.m_nPort;
		m_strAddress = dlg.m_strAddress;
	}
	else if (nResponse == IDCANCEL)
		return 0;

	// ziskat seznam stanic
	if(!GetStations())
		goto start;

getname:
	if(dlg2.DoModal() != IDOK)
		goto start;

	// vyhledat mozne stanice

	dlg2.m_strFrom.MakeLower();
	dlg2.m_strTo.MakeLower();
	dlg2.m_strVia.MakeLower();

	if(dlg2.m_strVia.IsEmpty())
		dlg3.m_bEmptyVia = true;
	else
		dlg3.m_bEmptyVia = false;

	for(size_t i=0;i<g_arrStations.size();i++)
	{
		CString lower = g_arrStations[i];
		lower.MakeLower();

		if(strstr(lower, dlg2.m_strFrom))
			dlg3.m_arrFrom.push_back(g_arrStations[i]);
		if(strstr(lower, dlg2.m_strTo))
			dlg3.m_arrTo.push_back(g_arrStations[i]);
		if(!dlg2.m_strVia.IsEmpty())
		{
			if(strstr(lower, dlg2.m_strVia))
				dlg3.m_arrVia.push_back(g_arrStations[i]);
		}
	}

	int volba = dlg3.DoModal();
	if(volba == -1)
		goto getname;
	else if(volba == IDCANCEL)
		goto start;

	DoRequest(dlg3.m_strFrom, dlg3.m_strTo, dlg3.m_strVia, dlg2.m_time.Format("%H%M"),
		dlg2.m_nMaxPrestupu, dlg2.m_nMaxSpojeni);

	// posledni dialog
	CVysledekDlg dlg4;
	dlg4.m_spojeni = &g_spojeni;

	dlg4.DoModal();

	return FALSE;
}

bool CklientApp::GetStations(void)
{
	CString strURL;
	IXMLDOMDocument2* pDocument;
	IXMLDOMNode *pRootNode, *pNode, *pSubNode;
	IXMLDOMNodeList* pNodeList;
	HRESULT hResult;
	BSTR name;

	strURL.Format("http://%s:%u/SeznamStanic", m_strAddress, m_nPort);
	
	hResult = ::CoCreateInstance(CLSID_DOMDocument30, NULL, CLSCTX_ALL, IID_IXMLDOMDocument2, (void**) &pDocument);

	if(!LoadXML(pDocument, strURL))
	{
		AfxMessageBox("Nelze nahrt seznam stanic");
		pDocument->Release();
		return false;
	}

	//MessageBox(GetDesktopWindow(),"Seznam stanic nacten", "OK", MB_ICONINFORMATION);

	pDocument->QueryInterface(IID_IXMLDOMNode, (void**) &pRootNode);
	pRootNode->get_nodeName(&name);
	SysFreeString(name);
	hResult = pRootNode->get_firstChild(&pSubNode);

	pSubNode->get_childNodes(&pNodeList);

	while(pNodeList->nextNode(&pNode) == S_OK)
	{
		BSTR text;
		pNode->get_nodeName(&name);

		if(wcsicmp(name, L"Stanice"))
		{
			::SysFreeString(name);
			pNode->Release();
			continue;
		}
		SysFreeString(name);

		pNode->get_text(&text);
		// a mame jmeno stanice

		//prevest na multibyte
		char szName[512];
		WideCharToMultiByte(0,0,text,-1,szName,512,NULL,NULL);

		g_arrStations.push_back(szName);

		::SysFreeString(text);
		pNode->Release();
	}

	pNodeList->Release();

	pSubNode->Release();
	pRootNode->Release();
	pDocument->Release();
	return true;
}

VARIANT StrVar(const char* str)
{
	size_t len = strlen(str)+1;
	wchar_t* wc = new wchar_t[strlen(str)+1];
	::MultiByteToWideChar(0,0,str,-1,wc,len);
	VARIANT var;
	var.vt = VT_BSTR;
	var.bstrVal = SysAllocString(wc);
	delete [] wc;
	return var;
}


bool CklientApp::DoRequest(CString strFrom, CString strTo, CString strVia, CString strTime, int prestupy, int vysledku)
{
	CString strURL;
	strFrom.Replace(' ', '+');
	strTo.Replace(' ', '+');
	strVia.Replace(' ', '+');

	if(strVia.IsEmpty())
	{
		strURL.Format("http://%s:%u/NajdiSpojeni?odkud=%s&kam=%s&odjezd=%s&prestupy=%d&spojeni=%d",
			this->m_strAddress, this->m_nPort, strFrom, strTo, strTime, prestupy, vysledku);
	}
	else
	{
		strURL.Format("http://%s:%u/NajdiSpojeni?odkud=%s&kam=%s&odjezd=%s&prestupy=%d&spojeni=%d&pres=%s",
			this->m_strAddress, this->m_nPort, strFrom, strTo, strTime, prestupy, vysledku, strVia);
	}

	IXMLDOMDocument2 * pDocument;
	IXMLDOMNode* pRootNode, *pSubNode, *pNode;
	IXMLDOMNodeList* pNodeList;
	HRESULT hResult;

	hResult = ::CoCreateInstance(CLSID_DOMDocument30, NULL, CLSCTX_ALL, IID_IXMLDOMDocument2, (void**) &pDocument);

	if(!LoadXML(pDocument, strURL))
	{
		return false;
	}

	pDocument->QueryInterface(IID_IXMLDOMNode, (void**) &pRootNode);
	pRootNode->get_firstChild(&pSubNode);
	pRootNode->Release();

	BSTR text;
	pSubNode->get_nodeName(&text);

	if(wcsicmp(text, L"Chyba") == 0)
	{
		AfxMessageBox("Intern chyba aplikace: klient poslal chybn poadavek.");
		PostQuitMessage(0);
		return false;
	}
	SysFreeString(text);

	pSubNode->get_childNodes(&pNodeList);

	while(pNodeList->nextNode(&pNode) == S_OK)
	{
		BSTR name;
		pNode->get_nodeName(&name);

		if(wcsicmp(name, L"Spoj") == 0)
		{
			IXMLDOMNode* pLinka;
			IXMLDOMNodeList* pNodeList;
			Spoj spoj;
			// zpracovat spoj

			pNode->get_childNodes(&pNodeList);

			while(pNodeList->nextNode(&pLinka) == S_OK)
			{
				// zpracovat linku
				Linka linka;
				IXMLDOMNamedNodeMap* pMap;
				IXMLDOMNode* pName;

				pLinka->get_attributes(&pMap);

				if(pMap->getNamedItem(L"cislo", &pName) == S_OK)
				{
					// jmeno linky
					NodeTextToCString(pName, linka.cislo);
					pName->Release();
				}

				pMap->Release();

				// ziskat seznam stanic
				IXMLDOMNodeList* pNodeList;
				IXMLDOMNode* pStanice;

				pLinka->get_childNodes(&pNodeList);

				while(pNodeList->nextNode(&pStanice) == S_OK)
				{
					BSTR name;
					// je to stanice?
					pStanice->get_nodeName(&name);

					if(wcsicmp(name, L"Stanice") == 0)
					{
						Stanice stanice;
						// zpracovat stanici
						IXMLDOMNamedNodeMap* pMap;
						IXMLDOMNode* pAttrib;

						pStanice->get_attributes(&pMap);
						
						if(pMap->getNamedItem(L"prijezd", &pAttrib) == S_OK)
						{
							NodeTextToCString(pAttrib, stanice.prijezd);
							pAttrib->Release();
						}
						if(pMap->getNamedItem(L"odjezd", &pAttrib) == S_OK)
						{
							NodeTextToCString(pAttrib, stanice.odjezd);
							pAttrib->Release();
						}

						pMap->Release();

						NodeTextToCString(pStanice, stanice.name);
						pStanice->Release();

						linka.stanice.push_back(stanice);
					}
					else if(wcsicmp(name , L"Poznamka") == 0)
					{
						CString text;
						NodeTextToCString(pStanice, text);
						linka.poznamky.push_back(text);
					}

					SysFreeString(name);
				}

				pNodeList->Release();

				pLinka->Release();

				spoj.linky.push_back(linka);
			}

			pNodeList->Release();

			g_spojeni.spoje.push_back(spoj);
		}

		SysFreeString(name);
		pNode->Release();
	}

	pNodeList->Release();

	pSubNode->Release();

	return true;
}

bool LoadXML(IXMLDOMDocument2* pDocument, CString strURL)
{
	VARIANT_BOOL bSuccessful;
	CInternetSession session;
	CStdioFile* pFile;
	char* buffer;
	wchar_t* buffer2;
	pFile = session.OpenURL(strURL);
	unsigned long read=0,len = 512*1024;

	buffer = new char[len+1];
	buffer2 = new wchar_t[len+1];

	while(1)
	{
		int thistime;
		thistime = pFile->Read(buffer+read, len-read);
		read += thistime;

		if(!thistime)
			break;
	}

	buffer[read] = 0;
	::MultiByteToWideChar(0,0,buffer,-1,buffer2,len+1);

	pDocument->loadXML(SysAllocString(buffer2), &bSuccessful);

	delete [] buffer;
	delete [] buffer2;

	return bSuccessful != 0;
}

void NodeTextToCString(IXMLDOMNode* pNode, CString& out)
{
	BSTR name;
	pNode->get_text(&name);

	::WideCharToMultiByte(0,0,name,-1,out.GetBuffer(256),256,0,0);
	out.ReleaseBuffer();

	::SysFreeString(name);
}
