// server.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <windows.h>
#include <msxml2.h>
#include <winsock.h>
#include <string>
#include <vector>
#include <process.h>

using namespace std;

SOCKET g_listen;
VARIANT StrVar(const char* str);
void NodeTextTostring(IXMLDOMNode* pNode, string& out);
void ServerThread(void*);

struct Stanice
{
	string odjezd,prijezd,name;
};
struct Linka
{
	string cislo;
	vector<Stanice> stanice;
	vector<string> poznamky;
};
vector<Linka> g_linky;

int _tmain(int argc, _TCHAR* argv[])
{
	::CoInitialize(NULL);

	IXMLDOMDocument2 * pDocument;
	IXMLDOMNode* pRootNode, *pSubNode, *pNode;
	IXMLDOMNodeList* pNodeList;
	HRESULT hResult;
	sockaddr_in addr;
	char szSourceFile[MAX_PATH] = "data.xml";
	char szSourceFile2[MAX_PATH];
	int port = 80;
	VARIANT_BOOL bSuccess;

	WSADATA data;
	WSAStartup(0x0101, &data);
	ZeroMemory(&addr, sizeof(addr));

	hResult = ::CoCreateInstance(CLSID_DOMDocument30, NULL, CLSCTX_ALL, IID_IXMLDOMDocument2, (void**) &pDocument);

	cout << "Zadejte path k datovemu souboru [data.xml]: ";
	cin.getline(szSourceFile2, MAX_PATH);

	if(strlen(szSourceFile2))
		strcpy(szSourceFile, szSourceFile2);

	cout << "Zadejte cislo portu: ";
	cin >> port;

	// naloadovat XML

	cout << "Parsing...\n";

	pDocument->load(StrVar(szSourceFile), &bSuccess);
	pDocument->QueryInterface(IID_IXMLDOMNode, (void**) &pRootNode);
	pRootNode->get_firstChild(&pSubNode);
	pRootNode->Release();

	pSubNode->get_childNodes(&pNodeList);
	while(pNodeList->nextNode(&pNode) == S_OK)
	{
		Linka linka;
		IXMLDOMNamedNodeMap* pMap;
		IXMLDOMNode* pNameNode, *pStanice;
		// Linka
		pNode->get_attributes(&pMap);

		if(pMap->getNamedItem(L"cislo", &pNameNode))
		{
			NodeTextTostring(pNameNode, linka.cislo);
			pNameNode->Release();
		}

		IXMLDOMNodeList* pNodeList;
		pNode->get_childNodes(&pNodeList);

		while(pNodeList->nextNode(&pStanice) == S_OK)
		{
			BSTR text;
			pStanice->get_nodeName(&text);

			if(wcsicmp(text, L"Stanice") == 0)
			{
				Stanice stanice;
				IXMLDOMNamedNodeMap* pMap;

				pStanice->get_attributes(&pMap);
				if(pMap->getNamedItem(L"prijezd", &pNameNode) == S_OK)
				{
					NodeTextTostring(pNameNode, stanice.prijezd);
					pNameNode->Release();
				}
				if(pMap->getNamedItem(L"odjezd", &pNameNode) == S_OK)
				{
					NodeTextTostring(pNameNode, stanice.odjezd);
					pNameNode->Release();
				}

				NodeTextTostring(pStanice, stanice.name);

				pMap->Release();
				linka.stanice.push_back(stanice);
			}
			else if(wcsicmp(text, L"Poznamka") == 0)
			{
				string text;
				NodeTextTostring(pStanice, text);
				linka.poznamky.push_back(text);
			}

			SysFreeString(text);
			pStanice->Release();
		}

		pNodeList->Release();

		pMap->Release();
		pNode->Release();

		g_linky.push_back(linka);
	}
	pNodeList->Release();

	pSubNode->Release();
	pDocument->Release();

	addr.sin_addr.s_addr = INADDR_ANY;
	addr.sin_port = htons(port);

	cout << "Bind & listen\n";

	g_listen = socket(AF_INET, SOCK_STREAM, 0);
	bind(g_listen, (sockaddr*) &addr, sizeof(sockaddr_in));
	listen(g_listen, 5);

	cout << "Ready\n";

	_beginthread(ServerThread, 0, 0);

	Sleep(INFINITE);

	::CoUninitialize();
	WSACleanup();
	return 0;
}

VARIANT StrVar(const char* str)
{
	size_t len = strlen(str)+1;
	wchar_t* wc = new wchar_t[strlen(str)+1];

	::MultiByteToWideChar(0,0,str,-1,wc,len);
	VARIANT var;
	var.vt = VT_BSTR;
	var.bstrVal = SysAllocString(wc);
	delete [] wc;
	return var;
}

void NodeTextTostring(IXMLDOMNode* pNode, string& out)
{
	BSTR name;
	pNode->get_text(&name);
	char* pBuf = new char[wcslen(name)+1];

	::WideCharToMultiByte(0,0,name,-1,pBuf,wcslen(name)+1,0,0);
	out = pBuf;
	delete [] pBuf;

	::SysFreeString(name);
}

void readline(SOCKET sock, char* buffer, int& nBufferUsed, char* out)
{
	while(true)
	{
		char* pos = (char*) memchr(buffer, '\n', nBufferUsed);
		if(pos)
		{
			memcpy(out, buffer, pos-buffer);
			char* pos2 = (char*) memchr(out, '\r', pos-buffer);

			if(pos2) *pos2 = 0;
			else out[pos-buffer] = 0;

			memmove(buffer, pos, nBufferUsed - (pos-buffer));
			nBufferUsed -= (pos-buffer);
			break;
		}
		else
		{
			int recvd = recv(sock, buffer + nBufferUsed, 4*1024-nBufferUsed, 0);
			if(recvd <= 0)
			{
				closesocket(sock);
				_endthread();
			}
			else
				nBufferUsed += recvd;
		}
	}
}

void ServerThread(void*)
{
	SOCKET client;
	sockaddr_in addr;
	char lineBuffer[4*1024];
	char szLine[512], szBufx[512];
	int nBufferUsed = 0;
	char szRequest[512];
	int size = sizeof(sockaddr_in);

	client = accept(g_listen, (sockaddr*) &addr, &size);
	_beginthread(ServerThread, 0, 0);

	readline(client, lineBuffer, nBufferUsed, szLine);
	do // zbavit se hlavicek
		readline(client, lineBuffer, nBufferUsed, szBufx);
	while(szBufx[0] != 0);

	char* pos = strchr(szLine, '/');
	char* pos2 = strchr(pos, ' ');
	strncpy(szRequest, pos, pos2-pos);

	cout << szRequest << endl;

	if(strcmp(szRequest, "/SeznamStanic") == 0)
	{
		IXMLDOMDocument2 * pDocument;
		IXMLDOMElement* pSubRoot;
		IXMLDOMNode* pRoot, *pSubRoot2, *pStanice;
		::CoCreateInstance(CLSID_DOMDocument30, NULL, CLSCTX_ALL, IID_IXMLDOMDocument2, (void**) &pDocument);

		pDocument->createElement(SysAllocString(L"SeznamStanic"), &pSubRoot);
		pDocument->QueryInterface(IID_IXMLDOMNode, (void**) &pRoot);
		pRoot->appendChild(pSubRoot, &pSubRoot2);
		pSubRoot->Release();

		for(size_t i=0;i<g_linky.size();i++)
		{
			for(size_t j=0;j<g_linky[i].stanice.size();j++)
			{
				wchar_t buf[512];
				IXMLDOMElement* pSubRoot;
				pDocument->createElement(SysAllocString(L"Stanice"), &pSubRoot);
				pSubRoot2->appendChild(pSubRoot, &pStanice);
				pSubRoot->Release();

				::MultiByteToWideChar(0,0,g_linky[i].stanice[j].name.c_str(), -1, buf, 512);

				pStanice->put_text(SysAllocString(buf));
			}
		}

		VARIANT dest;
		ZeroMemory(&dest, sizeof(dest));
		pDocument->save(dest);
		char* buf = new char[wcslen(dest.bstrVal)+1];

		::WideCharToMultiByte(0,0,dest.bstrVal, -1, buf, wcslen(dest.bstrVal)+1, 0,0);

		send(client, "HTTP/1.1 200 OK\r\n\r\n", 19, 0);
		int sent=0, len = strlen(buf);

		while(sent<len)
		{
			int thistime = send(client, buf, len-sent, 0);
			if(thistime <= 0)
			{
				closesocket(client);
				return;
			}
			else
				sent += thistime;
		}

		pRoot->Release();
		pDocument->Release();
	}
	else if(strncmp(szRequest, "/NajdiSpojeni?", 14) == 0)
	{
	}
	else
	{
		send(client, "HTTP/1.1 404 Not Found\r\n\r\n", 26 ,0);
	}
	closesocket(client);
}

